% Joe Jupin
% Homework 5

%  clear all variables
clear all;

%  read base image f
f = double(imread('phas1bw.jpg'));

% get size of image f
[xsize ysize] = size(f);

% read comparison images
gpics = {'phas2bw.jpg', 'phas3bw.jpg', 'phas4bw.jpg', 'phas5bw.jpg',
    'comm1bw.jpg', 'comm2bw.jpg', 'comm3bw.jpg', 'tric1bw.jpg'};
gnum = numel(gpics);
for i=1:gnum
    g(i, :, :) = double(imread(char(gpics(i))));
end

% set names of methods
met = {'PBS', 'PtPAb', 'PtPSq', 'PtPMV', 'NIP', 'Hist'};

% initialize result matrix
res = zeros(6, gnum);

%--------------------------------------------------
% Pixel Based Similarity
for p = 1:gnum
    for i=1:xsize
        for j=1:ysize
            res(1, p) = res(1, p) + (f(i, j)-g(p, i, j))^2;
        end
    end
    res(1, p) = sqrt(res(1, p));
    res(1, p);
end


%-----------------------------------------------------
% Pixel-to-Pixel Based Similarity with Absolute Values
for p = 1:gnum
    for i=1:xsize
        for j=1:ysize
            res(2, p) = res(2, p) + abs(f(i, j)-g(p, i, j));
        end
    end
    res(2, p);
end


%----------------------------------------------------
% Pixel-to-Pixel Based Similarity with Squared Values
for p = 1:gnum
    for i=1:xsize
        for j=1:ysize
            res(3, p) = res(3, p) + (f(i, j)-g(p, i, j))^2;
        end
    end
    res(3, p);
end


%---------------------------------------------------------------
% Stable Pixel-to-Pixel Based Similarity using Mean and Variance
for p = 1:gnum
    % get mean
    avg = 0;
    for i=1:xsize
        for j=1:ysize
            avg = avg + (f(i, j)-g(p, i, j));
        end
    end
    avg = avg/(xsize*ysize);

    % get variance
    var = 0;
    for i=1:xsize
        for j=1:ysize
            var = var + ((f(i, j)-g(p, i, j))-avg)^2;
        end
    end
    var = sqrt(var/(xsize*ysize-1));

    % get stable pixel-to-pixel based similarity using mean and variance
    if var ~= 0
        res(4, p) = sqrt(xsize*ysize)*(avg/var);
    else
        res(4, p) = 0;
    end
    res(4, p);
end


%----------------------------------------------
% Similarity Based on Normalized Inner Products
%e = zeros(gnum, 1);
vf = f(:);
for p = 1:gnum
    vg = g(p, :);
    res(5, p) = 1-((dot(vf, vg))/(norm(vf)*norm(vg)));
    res(5, p);
end


%-------------------------------
% Similarity Based on Histograms
% compute histogram f
Hf = double(zeros(256,1));
for i=1:numel(f)
    Hf(double(f(i))+1) = Hf(double(f(i))+1) + 1;
end

%h = zeros(gnum, 1);
for p=1:gnum
    % compute histogram g(i)
    Hg = double(zeros(256,1));
    for i=1:numel(g(p, :))
        Hg(double(g(p, i))+1) = Hg(double(g(p, i))+1) + 1;
    end

    % perform histogram similarity function on images
    for i=1:numel(Hf)
        res(6, p) = res(6, p) + (Hf(i)-Hg(i))^2;
    end
    res(6, p) = sqrt(res(6, p));
    res(6, p);
end


%-------------------
% Calculate Rankings
for i=1:6
    rank(i, 1) = met(i);
    for j=1:gnum
        [val, idx] = max(res(i, :));
        rank(i, (gnum+2)-j) = gpics(idx);
        res(i, idx) = -1000000;
    end
end

% show results
rank'
